﻿using Infragistics.Windows.DataPresenter;
using Microsoft.Xaml.Behaviors;
using System;
using System.Collections.Generic;
using System.Dynamic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XDGDependentComboCase
{
    public class DataGridUpdatedComboValueBehavior : Behavior<XamDataGrid>
    {
        private ViewModel GridViewModel { get; set; }

        protected override void OnAttached()
        {
            base.OnAttached();            
            this.AssociatedObject.DataValueChanged += AssociatedObject_DataValueChanged;            
        }

        private void AssociatedObject_DataValueChanged(object sender, Infragistics.Windows.DataPresenter.Events.DataValueChangedEventArgs e)
        {
            if(e.Field.Name == "ComboValue" && e.Record.Index == 0)
            {
                string newValue = ((SampleData)e.Record.DataItem).ComboValue;

                if(this.GridViewModel == null)
                {
                    this.GridViewModel = AssociatedObject.DataContext as ViewModel;
                }

                if(this.GridViewModel.DependentComboValue != null)
                {
                    CachedComboValue cached = this.GridViewModel.DependentComboValue;

                    if(cached.Index != 0)
                    {
                        this.GridViewModel.DependentComboValues.Insert(cached.Index, cached.Value);                        
                    }

                    this.GridViewModel.DependentComboValues.Remove(newValue);

                    int newIndex = this.GridViewModel.ComboValues.IndexOf(newValue);
                   
                    CachedComboValue newCache = new CachedComboValue() { Index = newIndex, Value = newValue };
                    this.GridViewModel.DependentComboValue = newCache;
                }
            }
        }
    }
}
